#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int>> ans;

void solve(){
    ans.clear();
    int n, m, s; cin >> n >> m >> s;

    vector<int> marko(n+1, -1);
    for(int i = 0; i < s; i++){
        int a; cin >> a;
        marko[a] = 0;
    }

    int vule = 1;
    vector<vector<int>> v(n+1);
    for(int i = 0; i < m; i++){
        int a, b; cin >> a >> b;
        v[a].push_back(b);
        v[b].push_back(a);
        if(marko[a] == -1) vule = a;
        if(marko[b] == -1) vule = b;

        if(marko[a] >= 0 && marko[b] == -1) marko[a] = b;
        if(marko[b] >= 0 && marko[a] == -1) marko[b] = a;
    }

    //provera da li ima vise komponenti bez marko cvorova
    queue<int> q;
    q.push(vule);
    int cnt = 0;
    vector<bool> flag(n+1, false);
    while(!q.empty()){
        int cvor = q.front();
        q.pop();

        if(flag[cvor] == false){
            flag[cvor] = true;
            cnt++;
        }
        else continue;
        for(int a : v[cvor]){
            if(!flag[a] && marko[a] == -1) q.push(a);
        }
    }

    if(cnt != n-s){
        cout << "-1\n"; return;
    }

    //pravljenje stabla od komponente
    for(int i = 0; i <= n; i++) flag[i] = false;
    q.push(vule);
    vector<bool> flag1(n+1, false);
    while(!q.empty()){
        int cvor = q.front();
        q.pop();

        flag[cvor] = true;

        for(int a : v[cvor]){
            if(!flag[a] && marko[a] == -1 && !flag1[a]){
                q.push(a);
                ans.push_back({cvor, a});
                flag1[a] = true;
            }
        }
    }

    //dodavanje marko cvorova
    for(int i = 1; i <= n; i++){
        if(marko[i] > 0) ans.push_back({i, marko[i]});
        else if(marko[i] == 0){
            cout << "-1\n"; return;
        }
    }

    cout << ans.size() << '\n';
    for(pair<int, int> par : ans){
        cout << par.first << ' ' << par.second << '\n';
    }
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int t; cin >> t;
    while(t--) solve();
    return 0;
}